Subject: [forces] generic forwarding element WAS(Re: Your recharter proposal

From: "Adrian Farrel" <[email-masked]>
Date: Tue, 2 Apr 2013 15:30:01 +0100

Thanks for the secondary pointer, Dave.
 
There was some interest in the WG in investigating the possible use of ForCES to
achieve what OpenFlow sets out to do. There were a couple of different
approaches proposed:
1. Replace OF with ForCES
2. Build a parallel mechanism/architecture
3. Model OF with ForCES
 
I don't want to rule any of these in or out except to note that the IETF cannot
dictate or control what the ONF does with OF, and we shouldn't try to. Thus,
item 1 is only likely to happen through the development of item 2 and the result
of market decisions, or through a specific choice by the ONF.
 
At this stage, it seem that any work in the "SDN" sphere may be a bit premature
for standardisation. Thus, when discussing this with Jamal, we agreed that the
WG should be open to the discussion of such topics, but should not (at this
stage) be committing to or taking on milestones or working group drafts on the
subject. Hence, the draft charter text says...
 
> In addition to the specific work items described below, it is understood that
> there are a number of external activities which may have interactions with the
> ForCES work.  Discussions of how to use ForCES to model topics of interest to
> Network Function Virtualization, I2RS, or OpenFlow may be discussed and
> reviewed, although primary responsibility for such documents is likely to live
> in other working groups, individual contributions, or other standards bodies.
 
So my advice to people interested in using ForCES for Foo is to write drafts and
discuss the topic. Also to write prototype code and demonstrate its utility.
 
Cheers,
Adrian

From: [email-masked] [mailto:[email-masked]] On Behalf Of
David Meyer
Sent: 02 April 2013 15:09
To: [email-masked]
Cc: [email-masked]
Subject: Re: [forces] Your recharter proposal
 
On Tue, Apr 2, 2013 at 6:36 AM, Ran Giladi <[email-masked]> wrote:
Hi ForCES,

Several years ago, I communicated with some of you, proposing to use ForCES
for SDN (not by this name, it was at the beginning of OpenFlow), claiming
that in order to stay relevant ForCES should target "SDN".

I'd like to use the opportunity and re-propose ForCES-based SDN, as
described in a paper I published in PRESTO'09, one of SIGCOM's workshops:
http://dl.acm.org/citation.cfm?id=1592637
 
For those who don't have ACM credentials, try
http://conferences.sigcomm.org/sigcomm/2009/workshops/presto/papers/p19.pdf
 
The main idea, in short, is to dictate (prescribe, force) a set of LFBs and
their interconnections (described in XML) on a generic data-plane platform,
using ForCES (we added OpenFlow later) LFBs and protocol, thus enabling the
generic platform to function as desired.
Applications can include OAM functionality, auto-learning, DPI, stateful
operations, and more, all (or most) at the data plane. It is a sort of a
superset of OpenFlow capabilities, based on ForCES.

I was able even to generate a Service Oriented Networking - using various
service indicators (in incoming frames) to initiate service functions, most
of them were executed at the data-plane. The first system was tested at
British Telecom Labs (at Ipswich), running an experimental scalable
Ethernet, using Network Processors (EZchip's). Recently my students were
able to port the code to plain Linux system.

If this is of interest, I can provide more info, including the Linux code.
 
I have been arguing that if OpenFlow evolves past 1.0 (basically L2 only) and
1.1+ (multi-table 1.0 with additional protocol features and which basically
unimplementable on ASIC h/w), then it will wind up looking very similar to
ForCES. In fact if you look at the proposal that Google made for what they were
calling OF 2.0 at the time, it has quite a bit in common with ForCES (at the
very least architecturally). I'm not sure if that proposal is publically
available anywhere but will check. 
 
I have been spending some time examining the architectural implications of the
OF mode (salient features are separation of control and data planes, open
interface to the forwarding/data plane (OF), and centralized control). Some of
my (controversial) thoughts are on
http://www.1-4-5.net/~dmm/talks/upperside_sdn_summit_paris_2013.pdf (this is
necessarily abbreviated; see something like
http://www.1-4-5.net/~dmm/talks/ncrg86.pdf for the longer form...)

--dmm

Ran

-----Original Message-----
From: [email-masked] [mailto:[email-masked]] On Behalf Of
Adrian Farrel
Sent: Tuesday, April 02, 2013 12:27 AM
To: [email-masked]
Subject: [forces] Your recharter proposal

Hi ForCES,

I have entered your proposed charter text at
https://datatracker.ietf.org/doc/charter-ietf-forces/

Since the meeting in Orlando I haven't heard a word of disquiet from you
about the charter so I am going to assume that you are all happy with what
is in/out within the bounds of understanding when you are in the rough.
Therefore, please shout loud and clear if that is not the case.

I am now going to set about some wordsmithing because the current proposal
is about 25 pages too long :-)

Cheers,
Adrian

_______________________________________________
forces mailing list
[email-masked]
https://www.ietf.org/mailman/listinfo/forces

_______________________________________________
forces mailing list
[email-masked]
https://www.ietf.org/mailman/listinfo/forces

---

From: David Meyer <[email-masked]>
Date: Tue, 2 Apr 2013 07:35:53 -0700

On Tue, Apr 2, 2013 at 7:30 AM, Adrian Farrel <[email-masked]> wrote:

> Thanks for the secondary pointer, Dave.****
>
> ** **
>
> There was some interest in the WG in investigating the possible use of
> ForCES to achieve what OpenFlow sets out to do. There were a couple of
> different approaches proposed:****
>
> 1. Replace OF with ForCES****
>
> 2. Build a parallel mechanism/architecture****
>
> 3. Model OF with ForCES****
>
> ** **
>
> I don't want to rule any of these in or out except to note that the IETF
> cannot dictate or control what the ONF does with OF, and we shouldn't try
> to. Thus, item 1 is only likely to happen through the development of item 2
> and the result of market decisions, or through a specific choice by the ONF.
> ****
>
> ** **
>
> At this stage, it seem that any work in the "SDN" sphere may be a bit
> premature for standardisation. Thus, when discussing this with Jamal, we
> agreed that the WG should be open to the discussion of such topics, but
> should not (at this stage) be committing to or taking on milestones or
> working group drafts on the subject. Hence, the draft charter text says...
> ****
>
> ** **
>
> > In addition to the specific work items described below, it is understood
> that****
>
> > there are a number of external activities which may have interactions
> with the****
>
> > ForCES work.  Discussions of how to use ForCES to model topics of
> interest to****
>
> > Network Function Virtualization, I2RS, or OpenFlow may be discussed and*
> ***
>
> > reviewed, although primary responsibility for such documents is likely
> to live****
>
> > in other working groups, individual contributions, or other standards
> bodies.****
>
> ** **
>
> So my advice to people interested in using ForCES for Foo is to write
> drafts and discuss the topic. Also to write prototype code and demonstrate
> its utility.****
>
> **
>

Makes sense to me. --dmm

> **
>
> Cheers,****
>
> Adrian****
>
> ** **
>
> ** **
>
> ** **
>
> *From:* [email-masked] [mailto:[email-masked]] *On
> Behalf Of *David Meyer
> *Sent:* 02 April 2013 15:09
> *To:* [email-masked]
> *Cc:* [email-masked]
> *Subject:* Re: [forces] Your recharter proposal****
>
> ** **
>
> On Tue, Apr 2, 2013 at 6:36 AM, Ran Giladi <[email-masked]> wrote:****
>
> Hi ForCES,
>
> http://dl.acm.org/citation.cfm?id=1592637****
>
> ** **
>
> ****
>  ****
> ****
> ** **
> I have been arguing that if OpenFlow evolves past 1.0 (basically L2 only)
> and 1.1+ (multi-table 1.0 with additional protocol features and which
> basically unimplementable on ASIC h/w), then it will wind up looking very
> similar to ForCES. In fact if you look at the proposal that Google made for
> what they were calling OF 2.0 at the time, it has quite a bit in common
> with ForCES (at the very least architecturally). I'm not sure if that
> proposal is publically available anywhere but will check. ****
>
> ** **
>
> I have been spending some time examining the architectural implications of
> the OF mode (salient features are separation of control and data planes,
> open interface to the forwarding/data plane (OF), and centralized control).
> Some of my (controversial) thoughts are on
> http://www.1-4-5.net/~dmm/talks/upperside_sdn_summit_paris_2013.pdf (this
> is necessarily abbreviated; see something like
> http://www.1-4-5.net/~dmm/talks/ncrg86.pdf for the longer form...)****
>
> ** **
>
> ** **
>
> --dmm****
>
> ** **
>
>
> Ran
>
> https://www.ietf.org/mailman/listinfo/forces****
>
> ** **
>